using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using C1.Win.C1Editor;


namespace Sample_ImageRendering
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        #region *** Methods
        //Returns the connection string for the datasource
        static string GetConnectionString()
        {
            string path = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\ComponentOne Samples\Common";
            string conn = @"provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;";
            return string.Format(conn, path);
        }
        #endregion

        #region *** Events
        //Form Load Event
        private void Form1_Load(object sender, EventArgs e)
        {
            //Set data source
            categoriesTableAdapter.Connection = new OleDbConnection(GetConnectionString());
            categoriesTableAdapter.Fill(this.c1NWindDataSet.Categories);
        }

        //Event to change images in the C1Editor
        private void c1DbNavigator1_PositionChanged(object sender, EventArgs e)
        {
            // make sure this is an embedded object
            const int bmData = 78;
            DataTable dt = c1NWindDataSet.Tables[0];
            byte[] picData = (byte[])dt.Rows[c1DbNavigator1.Position]["Picture"];

            try
            {
                MemoryStream s = new MemoryStream(picData, bmData, picData.Length - bmData);
                picData = s.ToArray();
                c1Editor1.Xml = "";
                var body = c1Editor1.Document.ChildNodes[1].ChildNodes[1];

                // create an element for the <img /> and add give it a name
                System.Xml.XmlElement img = c1Editor1.Document.CreateElement("test-img");

                // add an <img /> to the XmlElement and convert byte array to base64 string
                img.InnerXml = String.Format("<img width=\"200px;\" height=\"200px;\" src=\"data:image/bmp;base64,{0}\" />", Convert.ToBase64String(picData));
                // add XmlElement to the HTML body
                body.AppendChild(img);
            }
            catch (Exception ex)
            { }
        }

        //Change C1Editor Mode 
        private void toolStripStatusLabel1_Click(object sender, EventArgs e)
        {
            // set editor mode
            this.c1Editor1.Mode =
                sender == _lblDesign ? EditorMode.Design :
                sender == _lblSource ? EditorMode.Source :
                EditorMode.Preview;

            // highlight the selected option
            foreach (ToolStripLabel lbl in new ToolStripLabel[] { _lblDesign, _lblSource, _lblPreview })
            {
                lbl.BackColor = object.Equals(sender, lbl)
                    ? Color.Orange
                    : Color.Transparent;
            }
        }

        #endregion
    }
}